# Mouse Quest Demo
RU:
Да как же её... О, ты как раз вовремя! В общем, тут игра, называется Mouse Quest Demo. Да, знаю, оригинальное название для квеста. В общем она в принципе не сложная, но разработчики говорят, что они что-то сделали, чтобы пройти её могли только "избранные". Суть игры понятна, но вот как победить этого кота, я вообще не понимаю. Уже почти все свои деньги потратил. Не поможешь её пройти?

EN:
How can I get through… Oh, you're just in time! Basically this game is called Mouse Quest Demo. Yes, I know, this is the original name for the quest. In general, it is not difficult, but the developers say that they have done something to make it possible only for the “chosen ones”. The essence of the game is clear, but I don’t understand how to defeat this cat at all. Almost all my money has already been spent. Can you help me get through it?

[nc LOCALHOST 3333]
# Complexity

Easy

# Writeup

## Начальный анализ

1. Для начала нужно изучить структуру бинаря. Здесь нас интересуют несколько функций: createCat(), fight() и final().

![Step1](https://i.imgur.com/2rWgQUK.png)

2. Зайдя в функцию createCat, мы видим создание структуры, поэтому лучше всего создать структуру в Иде и поменять тип переменной.

![Step2](https://i.imgur.com/w1FZlh7.png)

### Как создать структуру?

<details>
	<summary>Click me</summary>
	1. Для создания структуры нужно перейти в окно структур (Windows->Structures).<br>
	2. Чтобы создать новую структуру, нужно нажать кнопку Insert. Так как функция называется createCat, поменяем имя созданной структуры на Cat.<br>
	3. Далее необходимо определить размер структуры. Для этого необходимо заново рассмотреть функцию createCat. В ней для переменной выделяется память размером в 12 (0xC) байт. При этом тип переменной result - DWORD *, т. е. под элементы данной переменной выделяется по 4 байта. Из этого делаем вывод, что в данной структуре содержится 3 элемента.<br>
	4. Для того, чтобы создать элемент структуры, необходимо нажать клавишу d. В этом случае будет создан элемент типа byte. Для того, чтобы изменить его тип нужно нажимать клавишу d до тех пор, пока не будет написано dd.<br>
	5. И создаем таким образом 3 элемента. Далее нужно будет просто поменять тип переменной result на "Cat *".<br>
</details>

Пример структуры:

![StructureEx](https://i.imgur.com/BlX4P09.png)

3. Далее рассмотрим функцию fight(). В ней мы можем увидеть 4 функции: feed(), play(), pet(), scare(). Причем, что интересно, судя по данному декомпилированному коду, мы можем ввести в консоль не одно действие, а сразу несколько подряд и они будут последовательно обрабатываться.

![Step3](https://i.imgur.com/PdHiQOD.png)

В функции feed() мы можем увидеть проверку field_8 (которая при инициализации структуры равняется 0). Остальные функции как раз меняют значение field_8, поэтому мы можем подобрать последовательность, меняющую field_8 на 100.
Но здесь есть еще одна интересная операция, которая находится на 7 строке. Здесь происходит аналог strcat со строкой food и конкатенируется она с массивом a3.

![FeedFunc](https://i.imgur.com/iwDZADb.png)

Нам известны такие операции с field_8:
1. pet (+3)
2. scare (-7)
3. play (\*2)

В данном случае, последовательностей, приводящих field_8 от 0 до 100 несколько. Вот пример одной из них - **131213131321213**

4. На данный момент с этой функцией мы разобрались, переходим к функции final(). Как мы можем видеть, она и выводит флаг (сам флаг берется из переменных окружения). А также она выводит строку "Congratulations, You did cat overflow!". Это подсказка о том, что, скорее всего, для получения флага, нужно сделать buffer overflow.

## Переполнение буфера

1. Вернемся в функцию fight(). Мы знаем, что скорее всего можем переполнить массив через функцию feed(), но зачем нам её переполнять? Ниже мы можем увидеть, что проверка символов идет до тех пор, пока переменная, которую я назвал flag не равна 0 (изначально она равна 1). Но она нигде не изменяется.

![BoF1](https://i.imgur.com/XMMuPCv.png)

2. Посмотрим на стек. Здесь мы видим, что переменная, которую можно переполнить (var_210), находится в стеке после переменной flag, а это значит, что при переполнении мы можем залезть на неё ноль байтом и тогда мы выйдем из цикла.

![BoF2](https://i.imgur.com/1CGWVx8.png)

3. Теперь проведем расчеты: чтобы переполнить переменную flag, мы должны записать 0x210 - 0x08 = 0x208 (520) байт. Так как мы добавляем каждый раз к массиву строку "food" нам нужно поделить это количество на 4 (не на 5, так как ноль байт каждый раз перезаписывается). Соответственно, получаем число 130 - это сколько раз мы должны вызвать функцию feed(), чтобы переполнить flag и записать в него ноль байт.

## Эксплуатация

Теперь, когда мы получили всю информацию о бинаре, можем переходить к самой эксплуатации уязвимости.

1. Подключаемся с помощью ncat к таску
2. Доходим до выполнения функции
3. Пишем номера функций, необходимых для выполнения функции feed()

![Exploit1](https://i.imgur.com/S0FR1Aw.png)

Получаем такой ответ:

![Exploit2](https://i.imgur.com/Zl03CXw.png)

Следовательно, мы убеждаемся, что пока все делаем правильно

4. Пишем 130 четверок, для того, чтобы функция feed вызвалась 130 раз и переписала переменную flag.

И получаем наш флаг:

![Exploit3](https://i.imgur.com/jZfYaBk.png)

Также это можно было сделать с помощью скрипта, который вы можете найти ./chal/solve.py

# Flag
mctf{3v3Ry_d4y_1S_l1K3_C4t_0V3rFl0w}